%define contentdir %_var/www/tclhttpd
Name: tclhttpd
Version: 3.5.1
Release: 13%{?dist}
Summary: Extensible Web+Application server written in Tcl

Group: System Environment/Daemons
License: BSD
URL:            http://tclhttpd.sourceforge.net/
Source0:        http://prdownloads.sourceforge.net/tclhttpd/tclhttpd3.5.1.tar.gz
Patch0:		tclhttpd_fedora.1.patch
Patch1:		tclhttpd-md5-3.5.1.patch
Patch2:		tclhttpd-3.5.1-nofork.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires: tcl-devel
Requires: tcl tclx tcllib fedora-usermgmt
Requires(post): /sbin/chkconfig
Requires(post): /sbin/service
Requires(preun): /sbin/chkconfig
Requires(preun): /sbin/service

%description
TclHttpd is a Web server implemented in pure Tcl. It works out of the box as a
Web server, but is really designed to be a Tcl application server. It supports
HTML+Tcl templates, and is extensible in a variety of ways.

%prep
%setup -q -n %{name}%{version}
%patch0 -p1
%patch1
%patch2 -p1

%build
%configure --with-serverroot=%{contentdir}
make %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT

make install DESTDIR=$RPM_BUILD_ROOT
install -p -D bin/redhat.init.tclhttpd $RPM_BUILD_ROOT/%{_initrddir}/tclhttpd
mkdir -p $RPM_BUILD_ROOT%_var/run/tclhttpd

# Move some of the libraries around so that we don't pollute the libdir.
# Eventually this fix should be put into the Makefile.
mv $RPM_BUILD_ROOT%{_libdir}/liblimit1.0.so $RPM_BUILD_ROOT%{_libdir}/limit1.0/
mv $RPM_BUILD_ROOT%{_libdir}/libcrypt1.0.so $RPM_BUILD_ROOT%{_libdir}/crypt1.0/
sed -e 's# \.\. # . #' < limit_pkgIndex.tcl > $RPM_BUILD_ROOT%{_libdir}/limit1.0/pkgIndex.tcl
sed -e 's# \.\. # . #' < crypt_pkgIndex.tcl > $RPM_BUILD_ROOT%{_libdir}/crypt1.0/pkgIndex.tcl

# Replace the numeric id in this configuration file with a name.  We don't
# know what numeric id it will end up with when it's created during
# the rpm installation.  Move the tclhttpd.rc file to a configuration
# directory so that it doesn't pollute the bin directory.
mkdir -p $RPM_BUILD_ROOT/%_sysconfdir/%{name}
mkdir -p $RPM_BUILD_ROOT/%_var/log/tclhttpd

# Set the user that tclhttpd will run as.
# Set the group that tclhttpd will run as.
# Set the default log file location.
# Turn off the debug password authorization for security reasons.
#    It can be turned on manually if needed.
sed -e 's/Config uid.*/Config uid tclhttpd/' \
        -e 's/Config gid.*/Config gid tclhttpd/' \
        -e 's#Config SSL_CADIR.*#Config SSL_CADIR "/etc/pki/tls/certs/"#' \
        -e 's#Config SSL_CAFILE.*#Config SSL_CAFILE "/etc/pki/tls/certs/ca-bundle.crt"#' \
        -e 's#Config SSL_CERTFILE.*#Config SSL_CERTFILE     [file join [Config SSL_CADIR] tclhttpd.pem]#' \
        -e 's#Config SSL_KEYFILE.*#Config SSL_KEYFILE     [file join [Config SSL_CADIR] tclhttpdkey.pem]#' \
        -e 's#Config LogFile.*#Config LogFile %_var/log/tclhttpd/log#' \
        -e 's/#Config Auth {}/Config Auth {}/' < bin/tclhttpd.rc > $RPM_BUILD_ROOT/%{_sysconfdir}/%{name}/tclhttpd.rc
sed -e 's/^Debug_Url.*/#&/' < bin/httpdthread.tcl > $RPM_BUILD_ROOT/%{_datadir}/%{name}%{version}/httpdthread.tcl

rm $RPM_BUILD_ROOT/%{_prefix}/bin/tclhttpd.rc
rm $RPM_BUILD_ROOT/%{_prefix}/bin/httpdthread.tcl
rm $RPM_BUILD_ROOT/%{contentdir}/tclhttpd.etc.init
# This cgi is precompiled and has some old libc dependencies.  It's been
# removed in the CVS head.  Until the next version is released, we remove
# it by hand here.
rm $RPM_BUILD_ROOT/%{contentdir}/htdocs/cgi-bin/env
mv $RPM_BUILD_ROOT/%{_prefix}/bin/httpd.tcl $RPM_BUILD_ROOT/%{_prefix}/bin/tclhttpd

# Creating ghosted files
mkdir -p $RPM_BUILD_ROOT/%{_var}/lock/subsys
touch $RPM_BUILD_ROOT/%{_var}/lock/subsys/tclhttpd
touch $RPM_BUILD_ROOT/%{_var}/run/tclhttpd/tclhttpd.pid

# Fix some file permissions.
find $RPM_BUILD_ROOT/%{contentdir}/htdocs -type f -exec chmod a-x {} \;
find $RPM_BUILD_ROOT/%{contentdir}/custom -type f -exec chmod a-x {} \;
find $RPM_BUILD_ROOT/%{contentdir}/htdocs -name \*.cgi -exec chmod a+x {} \;
find $RPM_BUILD_ROOT/%{contentdir}/custom -name \*.cgi -exec chmod a+x {} \;

%pre
# The "tclhttpd" user is used so that we don't have to run the
# server as "root" or "nobody".
user_uid=`id -u tclhttpd 2>/dev/null`
if [ x"$user_uid" = x ] ; then
    /usr/sbin/fedora-useradd 16 -c "Tclhttpd" -s /bin/false -d %{contentdir} -M tclhttpd
fi

%post
/sbin/chkconfig --add tclhttpd

%preun
if [ "$1" = "0" ]; then
    /sbin/service tclhttpd stop > /dev/null 2>&1
    /sbin/chkconfig --del tclhttpd
fi

%postun

if [ "$1" -ge "1" ]; then
    /sbin/service tclhttpd condrestart >/dev/null 2>&1
fi

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc README README.* WHATSNEW license.terms
%{_datadir}/%{name}%{version}
%{_bindir}/tclhttpd
%config(noreplace) %attr(-,tclhttpd,tclhttpd) %{_sysconfdir}/%{name}
%{_mandir}/man1/*
%config(noreplace) %contentdir
%dir %attr(-,tclhttpd,tclhttpd) %{_var}/run/tclhttpd
%attr(-,tclhttpd,tclhttpd) %{_var}/log/tclhttpd
%{_initrddir}/tclhttpd
%{_libdir}/crypt1.0
%{_libdir}/limit1.0
%doc src/README
%ghost %{_var}/lock/subsys/tclhttpd
%ghost %{_var}/run/tclhttpd/tclhttpd.pid

%changelog
* Fri Sep 1 2006 Wart <wart at kobold.org> - 3.5.1-13
- Rebulid for Fedora Extras
- Use condrestart instead of restart in %%postun

* Mon Apr 24 2006 Wart <wart at kobold.org> - 3.5.1-12
- Change default paths to ssl files to match Fedora default locations.
- Don't delete the tclhttpd user when uninstalling

* Fri Mar 31 2006 Wart <wart at kobold.org> - 3.5.1-11
- Don't create the tclhttpd home directory when adding the user.
- Added patch to disable [fork] if we're running in a threaded Tcl.
- Add newlines to make the ChangeLog more readable.

* Tue Feb 21 2006 Wart <wart at kobold.org> - 3.5.1-10
- Rebuild for FC5

* Fri Jan 27 2006 Wart <wart at kobold.org> - 3.5.1-9
- Added patch for utils.tcl to prevent error due to missing md5 function.

* Fri Jan 27 2006 Wart <wart at kobold.org> - 3.5.1-8
- Updated patch so that tclhttpd starts as root and then switches to
  the tclhttpd user.  This is necessary if tclhttpd is to listen
  on port 80.

* Sun Jan 21 2006 Wart <wart at kobold.org> - 3.5.1-7
- Check if the tclhttpd user exists before trying to create it

* Sun Jan 15 2006 Wart <wart at kobold.org> - 3.5.1-6
- Use ghosted files for runtime state files.
- Update patch to remove build dependency on autoconf.

* Tue Nov 22 2005 Wart <wart at kobold.org> - 3.5.1-5
- Move bin/httpdthread.tcl out of the bin directory.

* Sun Nov 20 2005 Wart <wart at kobold.org> - 3.5.1-4
- Use fedora_useradd/fedora_userdel to create/delete the tclhttpd user.
- Added BuildRequires: autoconf.
- Clean up file permissions to remove many rpmlint warnings.

* Thu Jul 7 2005 <wart at kobold.org> - 3.5.1-3
- Add 'restart' in the rpm postun stage.  Add post/preun requirements
  for /sbin/chkconfig and /sbin/service.
- Changed the default runlevel in the init script to '-' to prevent the
  service from being started by default.

* Thu Jun 30 2005 <wart at kobold.org> - 3.5.1-2
- Updated release tag to include %{dist}
- Don't include changes to the spec in the patchfile.
- run autoreconf in the prep stage, not the build stage.

* Fri Jun 17 2005 <wart at kobold.org> - 3.5.1-1
- Updated spec file to conform to Fedora Core 4 standards.

* Sat Nov 13 2004 <wart at kobold.org> - 3.5.1-0.fdr.8
- Change content directory again to prevent rpmlint warnings.
- Change ownership of content directory to prevent rpmlint warnings.
- Fixed rpmlint "incoherent subsys" warning.
- Move crypt and limit dynamically loadable modules into the proper
  subdirectories
- Turn off potentially insecure debug url.

* Sun Nov 7 2004 <wart at kobold.org> - 3.5.1-0.fdr.7
- Change content directory to /var/tclhttpd
- Move logs to /var/log/tclhttpd
- Remove the debug auth password.

* Wed Nov 3 2004 <wart at kobold.org> - 3.5.1-0.fdr.6
- Add missing #include <crypt.h> to crypt.c to fix a segfault on
  x86_64.

* Sat Oct 30 2004 <wart at kobold.org> - 3.5.1-0.fdr.5
- Add expect to the dependency list.
- Let tclhttpd fork into the background if either one of tclx
  or expect are available.
- Add existing docs to %doc list.
- Move configuration file to /etc/tclhttpd.
- Clean up some rpmlint warnings

* Sun Oct 24 2004 <wart at kobold.org> - 3.5.1-0.fdr.4
- Change package group in the specfile.  Add tcllib to dependency list.
  Remove tclhttpd user during uninstall.

* Wed Oct 6 2004 <wart at kobold.org> - 3.5.1-0.fdr.3
- Fix bug in the /etc/init.d/tclhttpd startup script that was causing
  it to kill a random tclsh process during shutdown, and misreporting
  the status of tclhttpd.

* Tue Sep 21 2004 <wart at kobold.org> - 3.5.1-0.fdr.2
- remove hardcoded path in the %build section of the rpm spec file.

* Sun Sep 12 2004 <wart at kobold.org> - 3.5.1-0.fdr.1
- Initial rpm with a Fedora-compatible spec file.  Included patch
  for better /etc/init.d script behaviour.
